package decorators;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.decorator.Decorator;
import javax.decorator.Delegate;
import javax.enterprise.inject.Any;
import javax.inject.Inject;

@Decorator
public class CoderDecorator implements Coder {

    @Inject
    @Delegate
    @Any
    @Chosen
    Coder coderdec;
    
    public static final Logger logger =
            Logger.getLogger(CoderDecorator.class.getCanonicalName());

    @Override
    public String codeString(String s, int tval) {
        logger.log(Level.INFO, "Entering decorator method.");
        int len = s.length();
        System.out.println("String " + s + " is " + len + " characters in length");
        return coderdec.codeString(s, tval);
    }
}
